<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8">
    <link href="https://brendan.ie/main.css" rel="stylesheet">
    <link href="./event_pointer.css" rel="stylesheet">

    <title>UL Module Timetable Builder</title>

    <meta content="UL Module Timetable Builder" name="title">
    <meta content="Brendan Golden" name="author">
    <meta content="Combine Multiple modules to make a (general) timetable" name="description">

    <!-- for mobile devices -->
    <meta content="width=device-width,initial-scale=1" name="viewport">
    <!-- brendan.coffee -->
    <link href="https://brendan.ie/coffee/coffee.css" rel="stylesheet">
    <script src="https://brendan.ie/coffee/coffee.js"></script>
  </head>
  <body class="sticky-wrapper">
    <div id="coffee_anchor"><span id="served"></span></div>
    <script>C0FFEE()</script>

    <header>
      <h1>UL Module Timetable Builder</h1>
      <h2>Combine Multiple modules to make a (general) timetable</h2>
      <p>
        This is designed to easily see what times everyone in a module is free.
        <br />
        Green == Free
        <br />
        Hover over grey to see what is on then.
      </p>
    </header>
    <main id="anchor">
      <p>
        <input id="module_input" type="text" placeholder="Enter Module Code">
        <button onClick="add()" type="button">
          Add
        </button>
        <select id="week_selector"></select>
        <button onClick="reset()" type="button">
          Clear
        </button>

        <br />
        <span id="module_list"></span>

      </p>
    </main>
    <footer>
      <span>
        <a href="https://gitlab.com/c2842/misc/ul_timetable_ical" rel='noopener noreferrer' target='_blank'>
          API source
        </a> | <wbr/>
        <a href="https://gitlab.com/brendan.ie/v1/-/blob/main/src/timetable/modules.html" rel='noopener noreferrer' target='_blank'>
          Page source
        </a>
      </span>
      <br/>
      <span>
        © 2021-<span id="year">2021</span> | <wbr/>
        Brendan Golden | <wbr/>
        Email: contact_me(at symbol)brendan.ie <a href="mailto:contact_website@brendan.ie"></a><a href="mailto:contact@brendan.ie"></a>  | <wbr/>
        Gitlab: <a href="https://gitlab.com/Brendan_Golden">Brendan_Golden</a> | <wbr/>
        Discord: Silver#5563 | <wbr/>
        Mastodon: <a rel="me" href="https://mastodon.brendan.ie/@silver">@silver</a>
      </span>
    </footer>
    <script>
      /* I am a lazy fucker */
      document.getElementById('year').textContent = new Date().getFullYear().toString()
    </script>
    <style>
      .firstSpan {
        color: rgb(119, 162, 241)
      }

      .firstSpan .secondSpan {
        visibility: hidden;
        width: 180px;
        background-color: gray;
        color: #fff;
        text-align: left;
        border-radius: 6px;
        padding: 5;
        position: absolute;
        z-index: 1;
        font-size: small;
      }

      .firstSpan:hover .secondSpan {
        visibility: visible;
      }
    </style>
    <script>
      let modules = {};
      let week = 0;

      run()
      async function run() {
        setup_textbox()
        setup_weeks();
        await add();
        await table_control();
      }

      // from https://stackoverflow.com/a/16011365
      function setup_textbox(){
        let wage = document.getElementById("module_input");
        wage.addEventListener("keydown", function (e) {
          if (e.code === "Enter") {  //checks whether the pressed key is "Enter"
            add();
          }
        });
      }

      function setup_weeks(){
        const list = document.getElementById("week_selector");
        for (let i=0; i<= 20; i++) {
          const list_item = document.createElement('option');
          list_item.id = `${i}_dropdown`;
          list_item.value = `${i}`;
          if(i === 0){
            list_item.innerText = `Any Week`;
          }else {
            list_item.innerText = `Week ${i}`;
          }

          list.appendChild(list_item);
         }
        list.addEventListener("change", handle_selection);

        document.getElementById(`0_dropdown`).selected = true;
      }

      function handle_selection() {
        let value_new = document.getElementById("week_selector").value;
        week = value_new - 0;
        table_control();
      }

      async function add(){
        let module_div = document.getElementById("module_input");
        let module = module_div.value.toUpperCase();

        if(module === ""){
          // module = "CS4222"
          return;
        }

        await fetch(`https://api.brendan.ie/timetable/classes/module?module=${module}`)
          // get the data
          .then((response) => {
            if (!response.ok) {
              console.error(`HTTP error! Status: ${response.status}`);
              return [];
            }
            return response.json();
          })
          .then((data) => {
            module_div.value = "";
            if(data.length === 0){
              return;
            }

            modules[module] = data;
            const div = document.createElement("span");
            div.id = `module_list_${module}`;

            // div.className = classname;
            div.appendChild(document.createTextNode(`${module} `));
            document.getElementById("module_list").appendChild(div);

            table_control()
          })
          .catch((err) => console.log(err));
      }

      async function reset(){
        modules = {};
        document.getElementById("module_list").replaceChildren();
        table_control()
      }

      const days = [
        'Monday',
        'Tuesday',
        'Wednesday',
        'Thursday',
        'Friday',
      ]
      const times = [
        9,
        10,
        11,
        12,
        13,
        14,
        15,
        16,
        17,
      ]


      function table_control() {
        let processed = {};

        for (const time of times) {
          processed[time] = {};

          for (const day of days) {
            processed[time][day] = [];
          }
        }

        for (const module of Object.values(modules)) {
          for (const lesson of module) {
            if(week > 0){
              if(!lesson.weeks.includes(week)){
                continue;
              }
            }

            for(let i = lesson.start; i<lesson.end; i++){
              processed[i][week_number_to_text(lesson.day)].push(lesson);
            }
          }
        }

        table_generate("timetable", processed)
      }


      function table_generate (id, processed) {
        // remove existing table (if exists)
        table_delete(id)
        // create a new table
        let table = table_create(id)
        table_create_head(table)
        table_create_body(table, processed)
      }

      function table_delete (table_id) {
        let table = document.getElementById(table_id)
        if (!table) {
          return
        }
        table.remove()
      }

      function table_create (table_id) {
        const table = document.createElement('table')

        const div = document.createElement('div')
        div.id = table_id

        div.appendChild(table)
        div.appendChild(document.createElement('br'))

        const anchor = document.getElementById('anchor')
        anchor.appendChild(div)

        return table
      }

      function table_create_head (table) {
        let thead = table.createTHead()

        // add the second row
        let row = thead.insertRow()
        row_add_cell(row, "");
        for (let key of days) {
          row_add_cell(row, key);
        }
      }

      function row_add_cell(row, value){
        let th = document.createElement('th');
        let text = document.createTextNode(value);
        th.appendChild(text);
        row.appendChild(th);
      }

      function week_number_to_text (n){
        switch (n){
          case 0 : return "Monday";
          case 1 : return "Tuesday";
          case 2 : return "Wednesday";
          case 3 : return "Thursday";
          case 4 : return "Friday";
          default : return "Not weekday";
        }
      }

      function table_create_body (table, processed) {
        for (const time of times) {
          let row = table.insertRow()

          let formatted = `${time}:00 - ${time+1}:00`;
          if(time < 10){
            formatted = `0${time}:00 - ${time+1}:00`;
          }
          // time
          let text = document.createTextNode(formatted)
          let cell = row.insertCell()
          cell.appendChild(text);


          for (const day of days) {
            let data = processed[time][day];

            let cell = row.insertCell();
            cell.className = "firstSpan";

            let inner_container = document.createElement('span');
            inner_container.className = "secondSpan";

            if (data.length === 0) {
              cell.style = 'background-color: green;'
            }

            for(const lesson of data){
              let inner = document.createElement('pre');

              let text = document.createTextNode(`${lesson.event}\n${lesson.lecturer}\n${lesson.location}`);
              inner.appendChild(text);
              inner_container.appendChild(inner);
              // <span class="secondSpan">A hint.</span><
            }

            cell.appendChild(inner_container);
          }
        }
      }
    </script>
  </body>
</html>